'use strict';

var _replaceBuffer;

function _load_replaceBuffer() {
  return _replaceBuffer = _interopRequireDefault(require('replace-buffer'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isWindows = typeof process !== 'undefined' && process.platform === 'win32';

var linebreak = isWindows ? '\r\n' : '\n';
var newLines = ['\r\n', '\r', '\n'];
var newline = /\r\n|\r|\n/g;

function converts(text, to) {
  var str = text;
  if (Buffer.isBuffer(text)) {
    newLines.forEach(function (newLine) {
      str = (0, (_replaceBuffer || _load_replaceBuffer()).default)(str, newLine, to);
    });
    return str;
  }
  return str.toString().replace(newline, to);
}

exports.lf = function (text) {
  return converts(text, '\n');
};

exports.auto = function (text) {
  return converts(text, linebreak);
};

exports.cr = function (text) {
  return converts(text, '\r');
};

exports.crlf = function (text) {
  return converts(text, '\r\n');
};